// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/PerceptionCameraParameters.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__PerceptionCameraParameters __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__PerceptionCameraParameters __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PerceptionCameraParameters_
{
  using Type = PerceptionCameraParameters_<ContainerAllocator>;

  explicit PerceptionCameraParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stereo_cameras_direction = 0;
      std::fill<typename std::array<double, 9>::iterator, double>(this->left_intrinsics.begin(), this->left_intrinsics.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->right_intrinsics.begin(), this->right_intrinsics.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->rotation_left_in_right.begin(), this->rotation_left_in_right.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->translation_left_in_right.begin(), this->translation_left_in_right.end(), 0.0);
    }
  }

  explicit PerceptionCameraParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    left_intrinsics(_alloc),
    right_intrinsics(_alloc),
    rotation_left_in_right(_alloc),
    translation_left_in_right(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stereo_cameras_direction = 0;
      std::fill<typename std::array<double, 9>::iterator, double>(this->left_intrinsics.begin(), this->left_intrinsics.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->right_intrinsics.begin(), this->right_intrinsics.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->rotation_left_in_right.begin(), this->rotation_left_in_right.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->translation_left_in_right.begin(), this->translation_left_in_right.end(), 0.0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _stereo_cameras_direction_type =
    uint8_t;
  _stereo_cameras_direction_type stereo_cameras_direction;
  using _left_intrinsics_type =
    std::array<double, 9>;
  _left_intrinsics_type left_intrinsics;
  using _right_intrinsics_type =
    std::array<double, 9>;
  _right_intrinsics_type right_intrinsics;
  using _rotation_left_in_right_type =
    std::array<double, 9>;
  _rotation_left_in_right_type rotation_left_in_right;
  using _translation_left_in_right_type =
    std::array<double, 3>;
  _translation_left_in_right_type translation_left_in_right;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__stereo_cameras_direction(
    const uint8_t & _arg)
  {
    this->stereo_cameras_direction = _arg;
    return *this;
  }
  Type & set__left_intrinsics(
    const std::array<double, 9> & _arg)
  {
    this->left_intrinsics = _arg;
    return *this;
  }
  Type & set__right_intrinsics(
    const std::array<double, 9> & _arg)
  {
    this->right_intrinsics = _arg;
    return *this;
  }
  Type & set__rotation_left_in_right(
    const std::array<double, 9> & _arg)
  {
    this->rotation_left_in_right = _arg;
    return *this;
  }
  Type & set__translation_left_in_right(
    const std::array<double, 3> & _arg)
  {
    this->translation_left_in_right = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__PerceptionCameraParameters
    std::shared_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__PerceptionCameraParameters
    std::shared_ptr<psdk_interfaces::msg::PerceptionCameraParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceptionCameraParameters_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->stereo_cameras_direction != other.stereo_cameras_direction) {
      return false;
    }
    if (this->left_intrinsics != other.left_intrinsics) {
      return false;
    }
    if (this->right_intrinsics != other.right_intrinsics) {
      return false;
    }
    if (this->rotation_left_in_right != other.rotation_left_in_right) {
      return false;
    }
    if (this->translation_left_in_right != other.translation_left_in_right) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceptionCameraParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceptionCameraParameters_

// alias to use template instance with default allocator
using PerceptionCameraParameters =
  psdk_interfaces::msg::PerceptionCameraParameters_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__STRUCT_HPP_
